package cn.ibizlab.businesscentral.core.odoo_survey.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.HashMap;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.businesscentral.core.odoo_survey.domain.Survey_label;
import cn.ibizlab.businesscentral.core.odoo_survey.filter.Survey_labelSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.alibaba.fastjson.JSONObject;

public interface Survey_labelMapper extends BaseMapper<Survey_label>{

    Page<Survey_label> searchDefault(IPage page, @Param("srf") Survey_labelSearchContext context, @Param("ew") Wrapper<Survey_label> wrapper) ;
    @Override
    Survey_label selectById(Serializable id);
    @Override
    int insert(Survey_label entity);
    @Override
    int updateById(@Param(Constants.ENTITY) Survey_label entity);
    @Override
    int update(@Param(Constants.ENTITY) Survey_label entity, @Param("ew") Wrapper<Survey_label> updateWrapper);
    @Override
    int deleteById(Serializable id);
     /**
      * 自定义查询SQL
      * @param sql
      * @return
      */
     @Select("${sql}")
     List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<Survey_label> selectByCreateUid(@Param("id") Serializable id) ;

    List<Survey_label> selectByWriteUid(@Param("id") Serializable id) ;

    List<Survey_label> selectByQuestionId(@Param("id") Serializable id) ;

    List<Survey_label> selectByQuestionId2(@Param("id") Serializable id) ;


}
